#include "gpaload.h"
#include <iostream>

using namespace std;

#undef GPA_FUNCTION_PREFIX
#define GPA_FUNCTION_PREFIX( f ) f ## PtrType f;

GPA_FUNCTION_PREFIX( GPA_Initialize )
GPA_FUNCTION_PREFIX( GPA_Destroy )

// Context
GPA_FUNCTION_PREFIX( GPA_OpenContext )
GPA_FUNCTION_PREFIX( GPA_CloseContext )
GPA_FUNCTION_PREFIX( GPA_SelectContext )

// Counter Interrogation
GPA_FUNCTION_PREFIX( GPA_GetNumCounters )
GPA_FUNCTION_PREFIX( GPA_GetCounterName )
GPA_FUNCTION_PREFIX( GPA_GetCounterDescription )
GPA_FUNCTION_PREFIX( GPA_GetCounterDataType )
GPA_FUNCTION_PREFIX( GPA_GetCounterUsageType )
GPA_FUNCTION_PREFIX( GPA_GetDataTypeAsStr )
GPA_FUNCTION_PREFIX( GPA_GetUsageTypeAsStr )
GPA_FUNCTION_PREFIX( GPA_GetStatusAsStr )

GPA_FUNCTION_PREFIX( GPA_EnableCounter )
GPA_FUNCTION_PREFIX( GPA_DisableCounter )
GPA_FUNCTION_PREFIX( GPA_GetEnabledCount )
GPA_FUNCTION_PREFIX( GPA_GetEnabledIndex )

GPA_FUNCTION_PREFIX( GPA_IsCounterEnabled )

GPA_FUNCTION_PREFIX( GPA_EnableCounterStr )
GPA_FUNCTION_PREFIX( GPA_DisableCounterStr )

GPA_FUNCTION_PREFIX( GPA_EnableAllCounters )
GPA_FUNCTION_PREFIX( GPA_DisableAllCounters )
GPA_FUNCTION_PREFIX( GPA_GetCounterIndex )

GPA_FUNCTION_PREFIX( GPA_GetPassCount )

GPA_FUNCTION_PREFIX( GPA_BeginSession )
GPA_FUNCTION_PREFIX( GPA_EndSession )

GPA_FUNCTION_PREFIX( GPA_BeginPass )
GPA_FUNCTION_PREFIX( GPA_EndPass )

GPA_FUNCTION_PREFIX( GPA_BeginSample )
GPA_FUNCTION_PREFIX( GPA_EndSample )

GPA_FUNCTION_PREFIX( GPA_GetSampleCount )

GPA_FUNCTION_PREFIX( GPA_IsSampleReady)
GPA_FUNCTION_PREFIX( GPA_IsSessionReady)
GPA_FUNCTION_PREFIX( GPA_GetSampleUInt64)
GPA_FUNCTION_PREFIX( GPA_GetSampleUInt32)
GPA_FUNCTION_PREFIX( GPA_GetSampleFloat32)
GPA_FUNCTION_PREFIX( GPA_GetSampleFloat64)

int loadGPAFunc()
{
    void *h = dlopen("libGPUPerfAPICL.so", RTLD_NOW);
    if(h==0)return -1;
    GPA_Initialize = (GPA_InitializePtrType)dlsym(h, "GPA_Initialize");
    GPA_Destroy = (GPA_DestroyPtrType)dlsym(h, "GPA_Destroy");
    GPA_OpenContext = (GPA_OpenContextPtrType)dlsym(h, "GPA_OpenContext");
    GPA_CloseContext = (GPA_CloseContextPtrType)dlsym(h, "GPA_CloseContext");
    GPA_SelectContext = (GPA_SelectContextPtrType)dlsym(h, "GPA_SelectContext");
    GPA_GetNumCounters = (GPA_GetNumCountersPtrType)dlsym(h, "GPA_GetNumCounters");
    GPA_GetCounterName = (GPA_GetCounterNamePtrType)dlsym(h, "GPA_GetCounterName");
    GPA_GetCounterDescription = (GPA_GetCounterDescriptionPtrType)dlsym(h, "GPA_GetCounterDescription");
    GPA_GetCounterDataType = (GPA_GetCounterDataTypePtrType)dlsym(h, "GPA_GetCounterDataType");
    GPA_GetCounterUsageType = (GPA_GetCounterUsageTypePtrType)dlsym(h, "GPA_GetCounterUsageType");
    GPA_GetDataTypeAsStr = (GPA_GetDataTypeAsStrPtrType)dlsym(h, "GPA_GetDataTypeAsStr");
    GPA_GetUsageTypeAsStr = (GPA_GetUsageTypeAsStrPtrType)dlsym(h, "GPA_GetUsageTypeAsStr");
    GPA_GetStatusAsStr = (GPA_GetStatusAsStrPtrType)dlsym(h, "GPA_GetStatusAsStr");
    GPA_EnableCounter = (GPA_EnableCounterPtrType)dlsym(h, "GPA_EnableCounter");
    GPA_DisableCounter = (GPA_DisableCounterPtrType)dlsym(h, "GPA_DisableCounter");
    GPA_GetEnabledCount = (GPA_GetEnabledCountPtrType)dlsym(h, "GPA_GetEnabledCount");
    GPA_GetEnabledIndex = (GPA_GetEnabledIndexPtrType)dlsym(h, "GPA_GetEnabledIndex");
    GPA_IsCounterEnabled = (GPA_IsCounterEnabledPtrType)dlsym(h, "GPA_IsCounterEnabled");
    GPA_EnableCounterStr = (GPA_EnableCounterStrPtrType)dlsym(h, "GPA_EnableCounterStr");
    GPA_DisableCounterStr = (GPA_DisableCounterStrPtrType)dlsym(h, "GPA_DisableCounterStr");
    GPA_EnableAllCounters = (GPA_EnableAllCountersPtrType)dlsym(h, "GPA_EnableAllCounters");
    GPA_DisableAllCounters = (GPA_DisableAllCountersPtrType)dlsym(h, "GPA_DisableAllCounters");
    GPA_GetCounterIndex = (GPA_GetCounterIndexPtrType)dlsym(h, "GPA_GetCounterIndex");
    GPA_GetPassCount = (GPA_GetPassCountPtrType)dlsym(h, "GPA_GetPassCount");
    GPA_BeginSession = (GPA_BeginSessionPtrType)dlsym(h, "GPA_BeginSession");
    GPA_EndSession = (GPA_EndSessionPtrType)dlsym(h, "GPA_EndSession");
    GPA_BeginPass = (GPA_BeginPassPtrType)dlsym(h, "GPA_BeginPass");
    GPA_EndPass = (GPA_EndPassPtrType)dlsym(h, "GPA_EndPass");
    GPA_BeginSample = (GPA_BeginSamplePtrType)dlsym(h, "GPA_BeginSample");
    GPA_EndSample = (GPA_EndSamplePtrType)dlsym(h, "GPA_EndSample");
    GPA_GetSampleCount = (GPA_GetSampleCountPtrType)dlsym(h, "GPA_GetSampleCount");
    GPA_IsSampleReady = (GPA_IsSampleReadyPtrType)dlsym(h, "GPA_IsSampleReady");
    GPA_IsSessionReady = (GPA_IsSessionReadyPtrType)dlsym(h, "GPA_IsSessionReady");
    GPA_GetSampleUInt64 = (GPA_GetSampleUInt64PtrType)dlsym(h, "GPA_GetSampleUInt64");
    GPA_GetSampleUInt32 = (GPA_GetSampleUInt32PtrType)dlsym(h, "GPA_GetSampleUInt32");
    GPA_GetSampleFloat32 = (GPA_GetSampleFloat32PtrType)dlsym(h, "GPA_GetSampleFloat32");
    GPA_GetSampleFloat64 = (GPA_GetSampleFloat64PtrType)dlsym(h, "GPA_GetSampleFloat64");
    return 0;
}

const char* getGPAError(GPA_Status status)
{
    switch(status)
    {
        case GPA_STATUS_OK: return "GPA_STATUS_OK";
        case GPA_STATUS_ERROR_NULL_POINTER: return "GPA_STATUS_ERROR_NULL_POINTER";
        case GPA_STATUS_ERROR_COUNTERS_NOT_OPEN: return "GPA_STATUS_ERROR_COUNTERS_NOT_OPEN";
        case GPA_STATUS_ERROR_COUNTERS_ALREADY_OPEN: return "GPA_STATUS_ERROR_COUNTERS_ALREADY_OPEN";
        case GPA_STATUS_ERROR_INDEX_OUT_OF_RANGE: return "GPA_STATUS_ERROR_INDEX_OUT_OF_RANGE";
        case GPA_STATUS_ERROR_NOT_FOUND: return "GPA_STATUS_ERROR_NOT_FOUND";
        case GPA_STATUS_ERROR_ALREADY_ENABLED: return "GPA_STATUS_ERROR_ALREADY_ENABLED";
        case GPA_STATUS_ERROR_NO_COUNTERS_ENABLED: return "GPA_STATUS_ERROR_NO_COUNTERS_ENABLED";
        case GPA_STATUS_ERROR_NOT_ENABLED: return "GPA_STATUS_ERROR_NOT_ENABLED";
        case GPA_STATUS_ERROR_SAMPLING_NOT_STARTED: return "GPA_STATUS_ERROR_SAMPLING_NOT_STARTED";
        case GPA_STATUS_ERROR_SAMPLING_ALREADY_STARTED: return "GPA_STATUS_ERROR_SAMPLING_ALREADY_STARTED";
        case GPA_STATUS_ERROR_SAMPLING_NOT_ENDED: return "GPA_STATUS_ERROR_SAMPLING_NOT_ENDED";
        case GPA_STATUS_ERROR_NOT_ENOUGH_PASSES: return "GPA_STATUS_ERROR_NOT_ENOUGH_PASSES";
        case GPA_STATUS_ERROR_PASS_NOT_ENDED: return "GPA_STATUS_ERROR_PASS_NOT_ENDED";
        case GPA_STATUS_ERROR_PASS_NOT_STARTED: return "GPA_STATUS_ERROR_PASS_NOT_STARTED";
        case GPA_STATUS_ERROR_PASS_ALREADY_STARTED: return "GPA_STATUS_ERROR_PASS_ALREADY_STARTED";
        case GPA_STATUS_ERROR_SAMPLE_NOT_STARTED: return "GPA_STATUS_ERROR_SAMPLE_NOT_STARTED";
        case GPA_STATUS_ERROR_SAMPLE_ALREADY_STARTED: return "GPA_STATUS_ERROR_SAMPLE_ALREADY_STARTED";
        case GPA_STATUS_ERROR_SAMPLE_NOT_ENDED: return "GPA_STATUS_ERROR_SAMPLE_NOT_ENDED";
        case GPA_STATUS_ERROR_CANNOT_CHANGE_COUNTERS_WHEN_SAMPLING: return "GPA_STATUS_ERROR_CANNOT_CHANGE_COUNTERS_WHEN_SAMPLING";
        case GPA_STATUS_ERROR_SESSION_NOT_FOUND: return "GPA_STATUS_ERROR_SESSION_NOT_FOUND";
        case GPA_STATUS_ERROR_SAMPLE_NOT_FOUND: return "GPA_STATUS_ERROR_SAMPLE_NOT_FOUND";
        case GPA_STATUS_ERROR_SAMPLE_NOT_FOUND_IN_ALL_PASSES: return "GPA_STATUS_ERROR_SAMPLE_NOT_FOUND_IN_ALL_PASSES";
        case GPA_STATUS_ERROR_COUNTER_NOT_OF_SPECIFIED_TYPE: return "GPA_STATUS_ERROR_COUNTER_NOT_OF_SPECIFIED_TYPE";
        case GPA_STATUS_ERROR_READING_COUNTER_RESULT: return "GPA_STATUS_ERROR_READING_COUNTER_RESULT";
        case GPA_STATUS_ERROR_VARIABLE_NUMBER_OF_SAMPLES_IN_PASSES: return "GPA_STATUS_ERROR_VARIABLE_NUMBER_OF_SAMPLES_IN_PASSES";
        case GPA_STATUS_ERROR_FAILED: return "GPA_STATUS_ERROR_FAILED";
        case GPA_STATUS_ERROR_HARDWARE_NOT_SUPPORTED: return "GPA_STATUS_ERROR_HARDWARE_NOT_SUPPORTED";
        default: return "GPA_UNKNOW_ERROR";
    }
}

void writeSession(gpa_uint32 session)
{
    gpa_uint32 counters,samples,counterIndex;
    GPA_Type type;
    char *name;
    GPA_GetEnabledCount(&counters);
    GPA_GetSampleCount(session, &samples);
    for(gpa_uint32 i=0;i<counters;i++)
    {
        GPA_GetEnabledIndex(i, &counterIndex);
        GPA_GetCounterName(counterIndex, (const char**)&name);
        GPA_GetCounterDataType(counterIndex, &type);
        cout << name << ":\t";
        for(gpa_uint32 o=0;o<samples;o++)
        {
            if(type == GPA_TYPE_UINT32)
            {
                gpa_uint32 value;
                GPA_GetSampleUInt32(session, o, counterIndex, &value);
                cout << value;
            }
            else if(type == GPA_TYPE_UINT64)
            {
                gpa_uint64 value;
                GPA_GetSampleUInt64(session, o, counterIndex, &value);
                cout << value;
            }
            else if(type == GPA_TYPE_FLOAT32)
            {
                gpa_float32 value;
                GPA_GetSampleFloat32(session, o, counterIndex, &value);
                cout << value;
            }
            else if(type == GPA_TYPE_FLOAT64)
            {
                gpa_float64 value;
                GPA_GetSampleFloat64(session, o, counterIndex, &value);
                cout << value;
            }
            cout << "\t";
        }
        cout << endl;
    }
    cout << "######################" << endl;
}
