#ifndef _GPALOAD_H_NOU_
#define _GPALOAD_H_NOU_

#include <GPUPerfAPI.h>
#include <GPUPerfAPIFunctionTypes.h>
#include <dlfcn.h>

#define GPA_FUNCTION_PREFIX( f ) extern f ## PtrType f;

GPA_FUNCTION_PREFIX( GPA_Initialize )
GPA_FUNCTION_PREFIX( GPA_Destroy )

// Context
GPA_FUNCTION_PREFIX( GPA_OpenContext )
GPA_FUNCTION_PREFIX( GPA_CloseContext )
GPA_FUNCTION_PREFIX( GPA_SelectContext )

// Counter Interrogation
GPA_FUNCTION_PREFIX( GPA_GetNumCounters )
GPA_FUNCTION_PREFIX( GPA_GetCounterName )
GPA_FUNCTION_PREFIX( GPA_GetCounterDescription )
GPA_FUNCTION_PREFIX( GPA_GetCounterDataType )
GPA_FUNCTION_PREFIX( GPA_GetCounterUsageType )
GPA_FUNCTION_PREFIX( GPA_GetDataTypeAsStr )
GPA_FUNCTION_PREFIX( GPA_GetUsageTypeAsStr )
GPA_FUNCTION_PREFIX( GPA_GetStatusAsStr )

GPA_FUNCTION_PREFIX( GPA_EnableCounter )
GPA_FUNCTION_PREFIX( GPA_DisableCounter )
GPA_FUNCTION_PREFIX( GPA_GetEnabledCount )
GPA_FUNCTION_PREFIX( GPA_GetEnabledIndex )

GPA_FUNCTION_PREFIX( GPA_IsCounterEnabled )

GPA_FUNCTION_PREFIX( GPA_EnableCounterStr )
GPA_FUNCTION_PREFIX( GPA_DisableCounterStr )

GPA_FUNCTION_PREFIX( GPA_EnableAllCounters )
GPA_FUNCTION_PREFIX( GPA_DisableAllCounters )
GPA_FUNCTION_PREFIX( GPA_GetCounterIndex )

GPA_FUNCTION_PREFIX( GPA_GetPassCount )

GPA_FUNCTION_PREFIX( GPA_BeginSession )
GPA_FUNCTION_PREFIX( GPA_EndSession )

GPA_FUNCTION_PREFIX( GPA_BeginPass )
GPA_FUNCTION_PREFIX( GPA_EndPass )

GPA_FUNCTION_PREFIX( GPA_BeginSample )
GPA_FUNCTION_PREFIX( GPA_EndSample )

GPA_FUNCTION_PREFIX( GPA_GetSampleCount )

GPA_FUNCTION_PREFIX( GPA_IsSampleReady)
GPA_FUNCTION_PREFIX( GPA_IsSessionReady)
GPA_FUNCTION_PREFIX( GPA_GetSampleUInt64)
GPA_FUNCTION_PREFIX( GPA_GetSampleUInt32)
GPA_FUNCTION_PREFIX( GPA_GetSampleFloat32)
GPA_FUNCTION_PREFIX( GPA_GetSampleFloat64)


int loadGPAFunc();
const char* getGPAError(GPA_Status status);
void writeSession(gpa_uint32 session);

#endif // _GPALOAD_H_NOU_
