#define DEVS_statecount(x) DEVS_statecount_function(event_vector, x)

float DEVS_statecount_function(_event *event_vector, float par)
{
    float count = 0;
    for(int i=0;i<NEIGHBOR;i++)
        count += event_vector[i].state == par ? 1 : 0;
    return count;
}

// without parameter function

#define DEVS_truecount() DEVS_statecount_function(event_vector, 1)
#define DEVS_falsecount() DEVS_statecount_function(event_vector, 0)
#define DEVS_undefcount() DEVS_statecount_function(event_vector, NAN)
#define DEVS_time() current_time
float DEVS_random(){                            return 0.5f; }
float DEVS_randomSign(){                        return 1.0f; }

//unary functions
float DEVS_abs(float par){				return fabs(par);}
float DEVS_acos(float par){				return acos(par);}
float DEVS_acosh(float par){			return acosh(par);}
float DEVS_asin(float par){				return asin(par);}
float DEVS_asinh(float par){			return asinh(par);}
float DEVS_atan(float par){				return atan(par);}
float DEVS_atanh(float par){			return atanh(par);}
float DEVS_cos(float par){				return cos(par);}
float DEVS_sec(float par){				return 1.0f/cos(par);}
float DEVS_sech(float par){				return 1.0f/cosh(par);}
float DEVS_exp(float par){				return exp(par);}
float DEVS_cosh(float par){				return cosh(par);}
float DEVS_fact(float par)
{
    float ret = 1,tmp;
    if(par == 0)return 1;
    if(par < 0 || fabs(fract(par, &tmp)) > 0.0001f)return NAN;
    unsigned int n = (unsigned int)par;
    while(n)
    {
        ret *= n;
        n--;
    }
    return ret;
}
float DEVS_fractional(float par){		float tmp; return fract(par, &tmp);}
float DEVS_ln(float par){				return log(par);}
float DEVS_log(float par){				return log10(par);}
float DEVS_round(float par){			return rint(par);}
float DEVS_cotan(float par){			return 1.0f/tan(par);}
float DEVS_cosec(float par){			return 1.0f/sin(par);}
float DEVS_cosech(float par){			return 1.0f/sinh(par);}
float DEVS_sign(float par){				if(par == 0)return 0; else return sign(par);}
float DEVS_sin(float par){				return sin(par);}
float DEVS_sinh(float par){				return sinh(par);}
float DEVS_sqrt(float par){				return sqrt(par);}
float DEVS_tan(float par){				return tan(par);}
float DEVS_tanh(float par){				return tanh(par);}
float DEVS_trunc(float par){			return trunc(par);}
float DEVS_truncUpper(float par){		return ceil(par);}
//TODO float DEVS_poisson(float par){	return (par);}
//TODO float DEVS_exponential(float par){	return (par);}
//TODO float DEVS_randInt(float par){	return (par);}
//TODO float DEVS_chi(float par){		return (par);}
float DEVS_asec(float par){				return acos(1.0f/par);}
float DEVS_acotan(float par){			return 0.5f*log((par+1)/(par-1));}
float DEVS_asech(float par){			return 2/(exp(par)+exp(-par));}
float DEVS_acosech(float par){			return par < -1.0f ? log((1-sqrt(1-par*par))/par) : log((1+sqrt(1-par*par))/par);}
//TODO float DEVS_nextPrime(float par){	return (par);}
float DEVS_radToDeg(float par){			return par/M_PI_F*180.0f;}
float DEVS_degToRad(float par){			return par/180.0f*M_PI_F;}
//TODO float DEVS_nth_prime(float par){	return (par);}
float DEVS_acotanh(float par){			return (par);}
float DEVS_CtoF(float par){				return par*9.0f/5.0f+32;}
float DEVS_CtoK(float par){				return par+273.15f;}
float DEVS_KtoC(float par){				return par-273.15f;}
float DEVS_KtoF(float par){				return par*9.0f/5.0f-459.67f;}
float DEVS_FtoC(float par){				return (par-32)*5.0f/9.0f;}
float DEVS_FtoK(float par){				return (par+459.67f)*5.0f/9.0f;}

// binary functions

