#ifndef _TEXTEDITOR_H_NOU_
#define _TEXTEDITOR_H_NOU_

#include <QTextEdit>
#include <QTextDocument>
#include <QSyntaxHighlighter>
#include "subwindowinterface.h"

class Hightligter : public QSyntaxHighlighter
{
    struct HightlightingRule
    {
        QRegExp pattern;
        QTextCharFormat format;
    };
    QVector<HightlightingRule> rules;

    public:
    Hightligter(QTextDocument *document);
    void highlightBlock(const QString &text);
};

class TextEditor : public QTextEdit, public SubWindowInterface
{
    Hightligter *highlighter;
    QTextDocument document;
    QString modelName;
    static int number;
    public:
    TextEditor(const QString &text, QWidget *parent = 0);
    ~TextEditor();
    static int getUntitledNumber(){ return number++; }
    QString getName(){ return modelName; }
    void setName(const QString &name);
    //SubWindowInterface metody
    void setSubWindowTitle();
    int load(const QString &file);
    int save(const QString &file);
    QString getFileName();
};

#endif // _TEXTEDITOR_H_NOU_
